November 2014

Sun Mon Tue Wed Thu Fri Sat
            1
2 3 4 5 6 7 8
9 10 11 12 13 14 15
16 17 18 19 20 21 22
23 24 25 26 27 28 29
30            










« Accessing the AutoCAD objects referred to by fields using .NET | Main | Accessing DWG files not open in the AutoCAD editor using .NET »

July 16, 2007

Using a palette from .NET to display properties of multiple AutoCAD objects

After a brief interlude we're back on the series of posts showing how to implement basic user-interfaces inside AutoCAD using .NET. Here's the series so far:

In this post we're going to swap out the modeless form we've been using in the last few posts in the series and replace it with an instance of AutoCAD's in-built palette class (Autodesk.AutoCAD.Windows.PaletteSet).

Firstly, why bother? Well, the PaletteSet class is realy cool: it provides docking, auto-hide, transparency and fixes the annoying focus-related issues we see with normal modeless dialogs.

And the best is that you get all this basically for free - the implementation work needed is really minimal. I started by copying liberal amounts of code from the DockingPalette sample on the ObjectARX SDK, and then deleted what wasn't needed for this project (which turned out to be most of it).

Here's the updated Command implementation. This really has very minor changes, as the palette implementation is all hidden inside the new TypeViewerPalette class.

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.DatabaseServices;

using Autodesk.AutoCAD.EditorInput;

using Autodesk.AutoCAD.Runtime;

using System;

using CustomDialogs;


namespace CustomDialogs

{

  public class Commands : IExtensionApplication

  {

    static TypeViewerPalette tvp;


    public void Initialize()

    {

      tvp = new TypeViewerPalette();


      DocumentCollection dm =

        Application.DocumentManager;

      dm.DocumentCreated +=

        new DocumentCollectionEventHandler(OnDocumentCreated);

      foreach (Document doc in dm)

      {

        doc.Editor.PointMonitor +=

          new PointMonitorEventHandler(OnMonitorPoint);

      }

    }


    public void Terminate()

    {

      try

      {

        DocumentCollection dm =

          Application.DocumentManager;

        if (dm != null)

        {

          Editor ed = dm.MdiActiveDocument.Editor;

          ed.PointMonitor -=

            new PointMonitorEventHandler(OnMonitorPoint);

        }

      }

      catch (System.Exception)

      {

        // The editor may no longer

        // be available on unload

      }

    }


    private void OnDocumentCreated(

      object sender,

      DocumentCollectionEventArgs e

    )

    {

      e.Document.Editor.PointMonitor +=

        new PointMonitorEventHandler(OnMonitorPoint);

    }


    private void OnMonitorPoint(

      object sender,

      PointMonitorEventArgs e

    )

    {

      FullSubentityPath[] paths =

        e.Context.GetPickedEntities();

      if (paths.Length <= 0)

      {

        tvp.SetObjectId(ObjectId.Null);

        return;

      };


      ObjectIdCollection idc = new ObjectIdCollection();

      foreach (FullSubentityPath path in paths)

      {

        // Just add the first ID in the list from each path

        ObjectId[] ids = path.GetObjectIds();

        idc.Add(ids[0]);

      }

      tvp.SetObjectIds(idc);

    }


    [CommandMethod("vt",CommandFlags.UsePickSet)]

    public void ViewType()

    {

      tvp.Show();

    }

  }

}

As for the TypeViewerPalette class: I started by migrating the SetObjectId[s]()/SetObjectText() protocol across from the old TypeViewerForm class - the most complicated part of which involved exposing the contents of our palette (which we define and load as a User Control) via a member variable that can be accessed from SetObjectText(). Other than that it was all just copy & paste.

Here's the C# code:

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.DatabaseServices;

using Autodesk.AutoCAD.EditorInput;

using Autodesk.AutoCAD.Interop;

using Autodesk.AutoCAD.Interop.Common;

using Autodesk.AutoCAD.Windows;

using TypeViewer;


namespace CustomDialogs

{

  public class TypeViewerPalette

  {

    // We cannot derive from PaletteSet

    // so we contain it

    static PaletteSet ps;


    // We need to make the textbox available

    // via a static member

    static TypeViewerControl tvc;


    public TypeViewerPalette()

    {

      tvc = new TypeViewerControl();

    }


    public void Show()

    {

      if (ps == null)

      {

        ps = new PaletteSet("Type Viewer");

        ps.Style =

          PaletteSetStyles.NameEditable |

          PaletteSetStyles.ShowPropertiesMenu |

          PaletteSetStyles.ShowAutoHideButton |

          PaletteSetStyles.ShowCloseButton;

        ps.MinimumSize =

          new System.Drawing.Size(300, 300);

        ps.Add("Type Viewer 1", tvc);

      }

      ps.Visible = true;

    }


    public void SetObjectText(string text)

    {

      tvc.typeTextBox.Text = text;

    }


    public void SetObjectIds(ObjectIdCollection ids)

    {

      if (ids.Count < 0)

      {

        SetObjectText("");

      }

      else

      {

        Document doc =

          Autodesk.AutoCAD.ApplicationServices.

            Application.DocumentManager.MdiActiveDocument;

        DocumentLock loc =

          doc.LockDocument();

        using (loc)

        {

          string info =

            "Number of objects: " +

            ids.Count.ToString() + "\r\n";

          Transaction tr =

            doc.TransactionManager.StartTransaction();

          using (tr)

          {

            foreach (ObjectId id in ids)

            {

              Entity ent =

                (Entity)tr.GetObject(id, OpenMode.ForRead);

              Solid3d sol = ent as Solid3d;

              if (sol != null)

              {

                Acad3DSolid oSol =

                  (Acad3DSolid)sol.AcadObject;


                // Put in a try-catch block, as it's possible

                // for solids to not support this property,

                // it seems (better safe than sorry)

                try

                {

                  string solidType = oSol.SolidType;

                  info +=

                    ent.GetType().ToString() +

                    " (" + solidType + ") : " +

                    ent.ColorIndex.ToString() + "\r\n";

                }

                catch (System.Exception)

                {

                  info +=

                    ent.GetType().ToString() +

                    " : " +

                    ent.ColorIndex.ToString() + "\r\n";

                }

              }

              else

              {

                info +=

                  ent.GetType().ToString() +

                  " : " +

                  ent.ColorIndex.ToString() + "\r\n";

              }

            }

            tr.Commit();

          }

          SetObjectText(info);

        }

      }

    }


    public void SetObjectId(ObjectId id)

    {

      if (id == ObjectId.Null)

      {

        SetObjectText("");

      }

      else

      {

        Document doc =

          Autodesk.AutoCAD.ApplicationServices.

            Application.DocumentManager.MdiActiveDocument;

        DocumentLock loc =

          doc.LockDocument();

        using (loc)

        {

          Transaction tr =

            doc.TransactionManager.StartTransaction();

          using (tr)

          {

            DBObject obj =

              tr.GetObject(id, OpenMode.ForRead);

            SetObjectText(obj.GetType().ToString());

            tr.Commit();

          }

        }

      }

    }

  }

}

Here's what you get when you run the VT command and manipulate the palette's docking/transparency before hovering over a set of drawing objects:

Palette_1

You can download the source for this project from here .

TrackBack

TrackBack URL for this entry:
http://www.typepad.com/services/trackback/6a00d83452464869e200e00993d5288833

Listed below are links to weblogs that reference Using a palette from .NET to display properties of multiple AutoCAD objects:

blog comments powered by Disqus

Feed/Share

10 Random Posts